/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#define disasm_null disasm_default
#define STUB_DEC(a) char *disasm_stub_##a(arm_inst_t,arm_addr_t,char*);

#define TABLE_DEF_BEGIN(a,b) \
  char *(*disasm_table_## a [b])(arm_inst_t,arm_addr_t,char *) = {
#define TABLE_DEF_END };

#define STUB_ENTRY(a) \
  char *disasm_stub_##a(arm_inst_t inst, arm_addr_t pc, char *buf)

#define FUNC_CALL(a) return disasm_##a(inst, pc, buf)
#define FUNC_NAME(a) disasm_##a
#define STUB_NAME(a) disasm_stub_##a
#define FUNC_DEFAULT disasm_default

#define TABLE_JUMP(a,b,c) return disasm_table_##a[(inst>>c)&b](inst,pc,buf)
#define PATTERN_TRUE(a,b) ((inst&a)==b)

#define MAIN_DECODE_ENTRY \
  char *disasm_main(arm_inst_t inst, arm_addr_t pc, char *buf)

