/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#ifndef _NWFPE_H
#define _NWFPE_H

#define FPE_ENTRY 0xd0000000
#define FPE_FPA11 0xd1000000
#define FPE_STACK 0xd2000000

#define FPE_FILE "/u/xzhu/arm_test_2/arm_rel/build/share/nwfpe.bin"

typedef emulator::arm_emulator armulator;

void impl_fpe(armulator *emu, arm_inst_t inst);
char *disasm_fpe(arm_inst_t inst, arm_addr_t addr, char *buf);

#define incr_fpe INST_FPE
#endif
