
#include "object_pool.h"

using namespace osm;

obj_pool::obj_pool(int n)
{
	objs.resize(n);
	for (int i=0; i<n; i++) objs[i] = new Object();
	freeList = objs;
	nFree = n;
}

obj_pool::~obj_pool() {
	std::vector<Object *>::iterator it;
	for (it=objs.begin(); it!=objs.end(); it++)
		delete *it;
}
