/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

using simulator::arm_simulator;

extern Itinerary *itn_default(arm_simulator *sim, arm_inst_t inst);

#define itn_null itn_default
#define STUB_DEC(a) Itinerary *itn_stub_##a(arm_simulator *,arm_inst_t);

#define TABLE_DEF_BEGIN(a,b) Itinerary *(*itn_table_## a [b])(arm_simulator *,arm_inst_t) = {
#define TABLE_DEF_END };

#define STUB_ENTRY(a) Itinerary *itn_stub_##a(arm_simulator *sim, arm_inst_t inst)

#define FUNC_CALL(a) return itn_##a(sim, inst)
#define FUNC_NAME(a) itn_##a
#define STUB_NAME(a) itn_stub_##a
#define FUNC_DEFAULT itn_default

#define TABLE_JUMP(a,b,c) return itn_table_##a[(inst>>c)&b](sim,inst)
#define PATTERN_TRUE(a,b) ((inst&a)==b)

#define MAIN_DECODE_ENTRY Itinerary *itn_main(arm_simulator *sim, arm_inst_t inst)

