/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#ifndef __DERIVED_ITINERARY_H__
#define __DERIVED_ITINERARY_H__

#include "itinerary.h"
#include <map>
#include <string>


typedef osm::itinerary Itinerary;
typedef osm::manager Manager;

namespace simulator {

enum {
#define xxx(a,b,c) ITN_ ## a,
#include "itin_list.h"
	ITN_TOTAL
};

#define xxx(a,b, c) \
typedef class b##_itinerary : public Itinerary { \
	public: \
		b##_itinerary(std::map<std::string, osm::manager *>& managers);\
		void setIds(uint32_t ids[]); \
} a##Itinerary;

#include "itin_list.h"

}

#endif
