/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#ifndef __MULT_ITIN__
#define __MULT_ITIN__

#include "misc.h"

using simulator::arm_simulator;

extern Itinerary *itn_mla(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mla_s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mul(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mul_s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_smull(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_smull_s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_smlal(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_smlal_s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_umull(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_umull_s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_umlal(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_umlal_s(arm_simulator *sim, arm_inst_t inst);

#endif

