/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#ifndef __LDST_ITIN__
#define __LDST_ITIN__

#include "misc.h"

using simulator::arm_simulator;
extern Itinerary *itn_ld1_imm(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ld1_imm_p(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ld1_imm_b(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ld1_imm_pb(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ld1_reg(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ld1_reg_p(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ld1_reg_b(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ld1_reg_pb(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ld2_imm(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ld2_reg(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st1_imm(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st1_imm_p(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st1_imm_b(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st1_imm_pb(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st1_reg(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st1_reg_p(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st1_reg_b(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st1_reg_pb(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st2_imm(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_st2_reg(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_swap(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_swap_byte(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_ldm(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_stm(arm_simulator *sim, arm_inst_t inst);

#endif
