#include "ns_arm.h"
#include "des.h"


#include <stdio.h>
#define TEXT_LENGTH 1024
#define TOTAL_COUNT 5
int main(){
  int scount, rcount;
  
  int address = ns_arm_get_addr();
  int i,d,a; 
  u8 in[TEXT_LENGTH];
  u8 send_buf[TEXT_LENGTH];
  u8 recv_buf[TEXT_LENGTH];
  u8 out[TEXT_LENGTH];
  u8 check[TEXT_LENGTH];

  /* init the input */
  for (i=0;i<TEXT_LENGTH;i++){
    in[i] = i;
    out[i] = 0;
    check[i] = 0;                  
    send_buf[i] = 0;
    recv_buf[i] = 0;
  }

 scount = rcount = TOTAL_COUNT;
 switch(address){ 
  
  case 2:
    // address = 0, node 0 case

    while( scount -- > 0){
      
      des_encrypt(key, in, send_buf, TEXT_LENGTH);
      d = ns_arm_send(5, send_buf, (TEXT_LENGTH/4));
      a = -1;

    }
    while( rcount -- > 0){
      do {
	    a = ns_arm_recv(8,recv_buf,(TEXT_LENGTH/4));
      }while ( a== -1);

    }
      /*
      for (i=0;i<TEXT_LENGTH;i++){
        printf("%d ",recv_buf[i]); 
      }
      */
          
     break;
 case 5:

    while( rcount -- >0){
      a = -1;
      do {
	a = ns_arm_recv(2, recv_buf,(TEXT_LENGTH/4));
      }while ( a== -1);
      /* then encrypt it */
      des_encrypt(key, recv_buf, send_buf, TEXT_LENGTH);
      /* send it to next one */
      d = ns_arm_send(8, send_buf, (TEXT_LENGTH/4));
    }
    break;

 case 8:     
   while( rcount -- >0){
      a = -1;
      do {
	a = ns_arm_recv(5, recv_buf,(TEXT_LENGTH/4));
      }while ( a== -1);
      /* then encrypt it */
      des_encrypt(key, recv_buf, send_buf, TEXT_LENGTH);
      /* send it to next one */
      d = ns_arm_send(2, send_buf, (TEXT_LENGTH/4));
    }
	  break;
  case 1:
    // address = 0, node 0 case

    while( scount -- > 0){
      
      des_encrypt(key, in, send_buf, TEXT_LENGTH);
      d = ns_arm_send(4, send_buf, (TEXT_LENGTH/4));
      a = -1;
    }
    while( rcount -- > 0){ 
      do {
	    a = ns_arm_recv(7,recv_buf,(TEXT_LENGTH/4));
      }while ( a== -1);
      /*
      for (i=0;i<TEXT_LENGTH;i++){
        printf("%d ",recv_buf[i]); 
      }
      */
    }       
     break;
 case 4:

    while( rcount -- >0){
      a = -1;
      do {
	a = ns_arm_recv(1, recv_buf,(TEXT_LENGTH/4));
      }while ( a== -1);
      /* then encrypt it */
      des_encrypt(key, recv_buf, send_buf, TEXT_LENGTH);
      /* send it to next one */
      d = ns_arm_send(7, send_buf, (TEXT_LENGTH/4));
    }
    break;

 case 7:     
   while( rcount -- >0){
      a = -1;
      do {
	a = ns_arm_recv(4, recv_buf,(TEXT_LENGTH/4));
      }while ( a== -1);
      /* then encrypt it */
      des_encrypt(key, recv_buf, send_buf, TEXT_LENGTH);
      /* send it to next one */
      d = ns_arm_send(1, send_buf, (TEXT_LENGTH/4));
    }
	  break;
  case 0:
    // address = 0, node 0 case

    while( scount -- > 0){
      
      des_encrypt(key, in, send_buf, TEXT_LENGTH);
      d = ns_arm_send(3, send_buf, (TEXT_LENGTH/4));
      a = -1;

    }
    while( rcount -- > 0){
      do {
	    a = ns_arm_recv(6,recv_buf,(TEXT_LENGTH/4));
      }while ( a== -1);
      /*
      for (i=0;i<TEXT_LENGTH;i++){
        printf("%d ",recv_buf[i]); 
      }
      */
    }       
     break;
 case 3:

    while( rcount -- >0){
      a = -1;
      do {
	a = ns_arm_recv(0, recv_buf,(TEXT_LENGTH/4));
      }while ( a== -1);
      /* then encrypt it */
      des_encrypt(key, recv_buf, send_buf, TEXT_LENGTH);
      /* send it to next one */
      d = ns_arm_send(6, send_buf, (TEXT_LENGTH/4));
    }
    break;

 case 6:     
   while( rcount -- >0){
      a = -1;
      do {
	a = ns_arm_recv(3, recv_buf,(TEXT_LENGTH/4));
      }while ( a== -1);
      /* then encrypt it */
      des_encrypt(key, recv_buf, send_buf, TEXT_LENGTH);
      /* send it to next one */
      d = ns_arm_send(0, send_buf, (TEXT_LENGTH/4));
    }
	  break;
   }	
    return 0;

  
}
