/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/


typedef emulator::arm_emulator armulator;

extern void impl_default(armulator *emu, arm_inst_t inst);

#define impl_null impl_default
#define STUB_DEC(a) void stub_##a(armulator *, arm_inst_t);

#define TABLE_DEF_BEGIN(a,b) void (*table_## a [b])(armulator *,arm_inst_t) = {
#define TABLE_DEF_END };

#define STUB_ENTRY(a) void stub_##a(armulator *emu, arm_inst_t inst)

#define FUNC_CALL(a) impl_##a(emu,inst)
#define FUNC_NAME(a) impl_##a
#define STUB_NAME(a) stub_##a
#define FUNC_DEFAULT impl_default

#define TABLE_JUMP(a,b,c) table_##a[(inst>>c)&b](emu,inst)
#define PATTERN_TRUE(a,b) ((inst&a)==b)

#define MAIN_DECODE_ENTRY void decode_main(armulator *emu,arm_inst_t inst)
