/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#ifndef __BRANCH_H__
#define __BRANCH_H__

typedef emulator::arm_emulator armulator;

void impl_branch(armulator *emu, arm_inst_t inst);		/*0xA0 - 0xAF*/
void impl_branch_link(armulator *emu, arm_inst_t inst);	/*0xB0 - 0xBF*/

char *disasm_branch(arm_inst_t, arm_addr_t, char *);		/*0xA0 - 0xAF*/
char *disasm_branch_link(arm_inst_t, arm_addr_t, char *);	/*0xB0 - 0xBF*/

#define incr_branch INST_BR
#define incr_branch_link INST_BL

#endif
