/***************************************************************************
                          loader.h  -  description
                             -------------------
    begin                : Wed Sep 26 2001
    copyright            : (C) 2001 CEA and Universit Paris XI Orsay
    author               : Gilles Mouchard
    email                : gilles.mouchard@lri.fr, gilles.mouchard@cea.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ARM_LOADER_H__
#define __ARM_LOADER_H__

typedef emulator::arm_emulator armulator;
void load_program(armulator *emu, const char *filename, bool quiet,
			int argc, char *argv[], char *envp[]);
void load_fpe(armulator *emu, const char *filename, bool quiet);

#endif
