/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#include "decode.h"
#include "decode_itin.h"
#include "derived_itinerary.h"
#include "itinerary_pool.h"
#include "armsim.h"

using namespace simulator;

Itinerary *itn_default(arm_simulator *sim, arm_inst_t inst)
{
#if 0 
	fprintf(stderr, "Attempted to decode a bogus opcode at 0x%08x"
		" (inst = 0x%08x), ignored...\n", PC-8, inst);
	return NULL;
#endif
	/*this is likely to be a speculative fetch, so give it a dummy*/
	Itinerary *itn = sim->itnq->allocate(ITN_DUMMY);
	return itn;
}

