/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#ifndef __STATREG_ITIN__
#define __STATREG_ITIN__

#include "misc.h"

using simulator::arm_simulator;

extern Itinerary *itn_mrs(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mrs_r(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_msr_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_msr_1r(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_msr_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_msr_2r(arm_simulator *sim, arm_inst_t inst);
#endif
